<template>
  <div class="contract-directions">
    <ObTable
      v-if="serviceDirections.length"
      ref="directionTable"
      :columns="columns"
      :page-limit="15"
      :items="serviceDirections"
      group-by="locationTitleFrom"
      group-slot-name="groupHeader"
      :is-group-action="isDraft"
      :group-action="groupAction"
      :functional-panel="false"
      :options-save-row="optionsTableSaveItem"
      add-button-text="Добавить направление"
      data-qa="contractDirectionsTable"
      @groupAction="onAddLocation"
    >
      <template slot="groupHeader" slot-scope="{ data }">
        <div class="direction-header">
          <div class="cell-to-direction">
            <i class="icon city-sm" />
            <span>{{ data.value }}</span>
          </div>
          <div
            v-if="isExistInternational(data)"
            class="locations-international"
          >
            <img
              src="./icons/world.svg"
              alt=""
            >
          </div>
          <div
            class="locations-count"
            :class="{
              '--danger': !data.items.length
            }"
          >
            Локаций: {{ data.items.length }}
          </div>
        </div>
      </template>
      <template slot="deleteButton" slot-scope="{ data }">
        <button
          v-if="isDraft"
          class="delete-button"
          @click.stop="deleteDirection(data.item)"
        >
          <i class="icon close" />
        </button>
      </template>
      <template slot="locationTitleTo" slot-scope="{ data }">
        <div class="location-to">
          <img
            v-if="data.item.routeCategory === 'INTERNATIONAL'"
            src="./icons/world.svg"
            alt=""
          >
          <i class="icon city-sm location-to__icon" />
          <span class="location-to__title">{{ data.item.locationTitleTo }}</span>
        </div>
      </template>
    </ObTable>
    <div
      v-if="!serviceDirections.length"
      class="no-data-text"
    >
      Сейчас услуга действует для всех направлений по онлайн-ценам.<br>
      Добавьте направления, чтобы настроить для них стоимость.
    </div>

    <ObButton
      v-if="isDraft"
      label="Добавить направление"
      icon="plus"
      :mini="true"
      class="contract-directions__add-button"
      @click="onAddDirection"
    />

    <ObModal
      ref="directionModal"
      :title-second="titleSecondModal"
      :title="titleModal"
      size="large"
      data-qa="contractDirection"
    >
      <component
        ref="directionComponent"
        :is="directionFormComponent"
        :data-source="editedData"
        :service="service"
        @on-disable-direction="deleteDirection"
        @submit="saveDirection"
      />
    </ObModal>
  </div>
</template>

<script>
import api from '@/api'
import { mapState, mapGetters } from 'vuex'
import ObTable from 'common-components/src/obComponents/obTable'
import DirectionForm from '@/components/Contract/detail/services/directionsNew/Form'
import DirectionFormAdditional from '@/components/Contract/detail/services/directionsNew/FormAdditional'
import ObModal from 'common-components/src/obComponents/obModal'
import ObButton from 'common-components/src/obComponents/obButton'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect'
import ObSwitcher from "common-components/src/obComponents/obSwitcher"
import { formatNumber } from 'common-components/src/helpers/common'
import cloneDeep from 'clone-deep'
import debounce from "debounce";

export default {
  name: 'ContractDirectionsList',
  components: {
    ObTable,
    DirectionForm,
    ObModal,
    ObMenuDropdown,
    ObButton,
    ObInlineSelect,
    ObSwitcher
  },
  props: {
    service: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      api,
      serviceDirections: [],
      editedData: null,
      loadingProcess: {},
      groupAction: {
        index: 1,
        icon: 'plus',
        text: 'Добавить локацию'
      },
      optionsTableSaveItem: {
        onSubmit: async (data) => {
          await this.calcTariff(data)
        }
      }
    }
  },
  mounted () {
    this.getServiceDirections()
  },
  computed: {
    ...mapState({
      contract: state => state.contract.contract
    }),
    ...mapGetters({
      isDraft: 'contract/isDraft',
      isVatPayer: 'contract/isDoerVatPayer'
    }),
    directionFormComponent () {
      const componentMap = {
        SIMPLE: DirectionForm,
        BASE: DirectionForm,
        ADDITIONAL: DirectionFormAdditional
      }
      return componentMap[this.service.type] || DirectionForm
    },
    columns () {
      return [
        {
          title: ' ',
          key: 'locationTitleFrom',
          sortDisable: true,
          html: () => '',
          width: 80
        },
        {
          title: 'Куда',
          key: 'locationTitleTo',
          slotName: 'locationTitleTo',
        },
        {
          title: 'Тариф (без ндс)',
          key: 'tariff',
          html: (data) => this.tariffHtml(data),
          isAlignRight: true,
          width: 150
        },
        {
          title: 'Величина НДС',
          key: 'vatAmount',
          html: (data) => this.vatHtml(data),
          isAlignRight: true,
          width: 150
        },
        {
          title: 'Ставка НДС',
          key: 'vatAmount',
          html: (data) => this.vatRateHtml(data),
          isAlignRight: true,
          width: 150
        },
        {
          title: 'Итоговый тариф',
          key: 'tariffTotal',
          isEditColumn: this.contract.status !== 'SIGNED',
          isRequired: true,
          isAlignRight: true,
          valueType: 'MONEY',
          html: (data) => this.tariffTotalHtml(data),
          handler: data => Math.abs(data)
        },
        {
          title: ' ',
          slotName: 'deleteButton',
          sortDisable: true,
          action: true,
          width: 40
        }
      ]
    },
    serviceTitleByType () {
      if (!this.service.type) return ''
      let types = [
        {
          uuid: 'SIMPLE',
          title: 'Базовые'
        },
        {
          uuid: 'MULTISTOP',
          title: 'Мультистоповые',
          isDisabled: true
        },
        {
          uuid: 'MULTIMODAL',
          title: 'Мультимодальные',
          isDisabled: true
        },
        {
          uuid: 'ADDITIONAL',
          title: 'Дополнительные',
          isDisabled: true
        }
      ]

      return types.find((item) => item.uuid === this.service.type).title
    },
    titleModal () {
      return this.editedData?.directionUuid ? `Направление «${this.editedData.locationTitleFrom} → ${this.editedData.locationTitleTo}»` : 'Направление'
    },
    titleSecondModal () {
      if (!this.isDraft) {
        return 'Просмотр'
      }
      return this.editedData?.directionUuid ? 'Редактирование' : 'Добавление'
    }
  },
  methods: {
    isLoading (uuid) {
      return Boolean(this.loadingProcess[uuid])
    },
    async getServiceDirections () {
      const res = await api.contract.getServiceDirections({ uuid: this.service.uuid })
      this.serviceDirections = res.content
    },
    onAddDirection () {
      this.editedData = null
      this.$refs.directionModal.open()
    },
    onAddLocation (data) {
      let { locationFromUuid, locationTitleFrom } = cloneDeep(data.items?.[0]?.item)
      this.editedData = {
        serviceUuid: this.serviceUuid,
        locationFromUuid,
        locationFromTitle: locationTitleFrom
      }
      this.$refs.directionModal.open()
    },
    async deleteDirection ({ directionUuid }) {
      this.$nextTick(async () => {
        try {
          await api.contract.deleteDirection({ uuid: directionUuid })
          this.$notification({
            type: 'system_notification_success',
            message: `Направление удалено`
          })
          setTimeout(() => {
            this.getServiceDirections()
            this.$emit('on-update')
          }, 1000)
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: `Ошибка удаления направления`
          })
        } finally {
          this.loadingProcess[directionUuid] = false
        }
      })
    },
    async saveDirection ({ formData }) {
      formData.serviceUuid = this.service.uuid
      try {
        if (formData.directionUuid) {
          await api.contract.updateDirection({ data: formData, uuid: formData.directionUuid })
        } else {
          await api.contract.createDirection({ data: formData, uuid: this.service.uuid })
        }
        this.$notification({
          type: 'system_notification_success',
          message: `Направление ${this.editedService ? 'обновлено' : 'добавлено'}`
        })
        this.$refs.directionModal.close()

        setTimeout(() => {
          this.getServiceDirections()
          this.$emit('on-update')
        }, 1000)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка ${this.editedService ? 'обновления' : 'добавления'} направления`
        })
      }
    },
    async updatePrice ({ data }) {
      try {
        await api.contract.updateDirection({ data, uuid: data.directionUuid })

        this.$notification({
          type: 'system_notification_success',
          message: 'Тариф сохранен'
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка сохранения тарифа'
        })
      }
    },
    async selectDirection ({ directionUuid }) {
      try {
        let res = await api.contract.getDirectionDetail({ uuid: directionUuid })

        res = {
          ...res,
          ...res.tariffs
        }
        this.editedData = { ...res }
        // this.$refs.directionModal.open()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка загрузки данных направления`
        })
      }
    },
    toHtml (data) {
      return `<div class="cell-to-direction"><i class="icon ${data.to_icon}"></i><span>${data.to}</span></div>`
    },
    tariffHtml (data) {
      if (!data.tariff?.priceWithoutVat) {
        return `<span class="-gray-slate">Онлайн-цена</span>`
      }
      return `<span>${formatNumber(data.tariff?.priceWithoutVat / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    vatHtml (data) {
      return data.vatRate ? (formatNumber(data.tariff?.vatPrice / 100, { dot: 2 }) + ' ₽') : ``
    },
    tariffTotalHtml (data) {
      return `<span>${formatNumber(data.tariffTotal / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    tableGroupTitleHtml (value) {
      return `<div class="cell-to-direction"><i class="icon city-sm"></i><span>${value}</span></div>`
    },
    vatRateHtml (data) {
      return `${data.vatType !== 'NO_VAT' ? data.vatRate + '%' : ''}`
    },
    isExistInternational (data) {
      return data.items.some(item => item.item.routeCategory === 'INTERNATIONAL')
    },
    calcTariff: debounce(async function(data) {
      const { vatType, vatRate, tariffTotal } = data

      const postData = {
        vatRate: vatRate,
        quantity: 1,
        priceWithVat: tariffTotal
      }

      if (vatType !== 'NO_VAT') {
        const { itemsList } = await api.orderProcess.vatCalculation({ list: [ postData ] })
        const { priceWithVat = '', priceWithoutVat = '', vatValue = '' } = itemsList[0] || {}

        data.tariff.priceWithVat = priceWithVat
        data.tariff.priceWithoutVat = priceWithoutVat
        data.tariff.vatPrice = vatValue
      } else {
        data.tariff.priceWithVat = tariffTotal
        data.tariff.priceWithoutVat = tariffTotal
        data.tariff.vatPrice = 0
      }

      await this.updatePrice({ data })
    }, 500),
  }
}
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/variables';
  @import "~common-components/src/static/css/mixins";

  .contract-directions {
    padding: 10px 0 30px 80px;
    .no-data-text {
      margin-bottom: 20px;
      margin-top: 10px;
      @include font-mixin(14px, 18px, 400, $color-grey-label);
    }
    table {
      min-width: auto!important;
    }
    .menu-button-danger {
      button {
        color: $color-error;
      }
    }

    &::v-deep {
      .ob-input-container {
        max-width: 120px;
      }
      .ob-table-inner {
        margin-bottom: 20px;
        flex-grow: 2;
        tr th {
          border-top: none!important;
          box-shadow: none!important;
        }
        .ob-menu-dropdown-container:not(.--opened) {
          opacity: 0;
          pointer-events: none;
        }
        tr:hover {
          .ob-menu-dropdown-container {
            opacity: 1;
            pointer-events: all;
          }
        }
        td {
          &:last-child {
            .td-container {
              justify-content: flex-end;
            }
          }
        }
        .groupAction {
          margin-top: 4px;
          margin-bottom: 20px;
        }
        .obInputField .ob-input-wrap {
          padding-top: 5px!important;
          padding-bottom: 5px !important;
        }
      }
    }
  }

  .direction-header {
    width: 100%;
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding-right: 90px;
    .cell-to-direction {
      display: flex;
      align-items: center;
      @include font-mixin(14px, 20px, 400, $color-blue-navy-blue);
      .icon {
        margin-right: 12px;
        font-size: 14px;
        color: $color-blue-navy-blue;
      }
    }
    .locations-count {
      width: 173px;
      text-align: right;
      @include font-mixin(12px, 20px, 400, $color-blue-navy-blue);
      &.--danger {
        color: $color-error;
      }
    }

    .locations-international {
      flex-grow: 2;
      text-align: right;
    }
  }

  .location-to {
    position: relative;
    display: flex;
    align-items: center;
    img {
      position: absolute;
      left: -35px;
      top: -1px;
    }
    &__icon {
      margin-right: 10px;
      font-size: 14px;
      color: $color-blue-navy-blue;
    }
    &__title {
      @include font-mixin(14px, 18px, 400, #000);
    }
  }

  .delete-button {
    margin: 0;
    padding: 3px;
    background-color: transparent;
    border: none;
    outline: none;
    cursor: pointer;
    .icon {
      font-size: 16px;
      color: $color-grey-span;
    }
    &:hover {
      .icon {
        color: $color-error;
      }
    }
  }

  .fadeIn-enter,
  .fadeIn-leave-to {
    opacity: 0;
  }

  .fadeIn-enter-active,
  .fadeIn-leave-active {
    transition: opacity .3s ease-in-out;
  }
</style>
